Ruby: ext/zlib/zlib-1.2.13/zlib.h File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Data Structures | Macros | Typedefs | Functions
zlib.h File Reference
`#include "zconf.h"`

Go to the source code of this file.

## Data Structures
struct | z_stream_s
struct | gz_header_s
struct | gzFile_s

## Macros
#define | ZLIB_VERSION "1.2.13"
#define | ZLIB_VERNUM 0x12d0
#define | ZLIB_VER_MAJOR 1
#define | ZLIB_VER_MINOR 2
#define | ZLIB_VER_REVISION 13
#define | ZLIB_VER_SUBREVISION 0
#define | Z_NO_FLUSH 0
#define | Z_PARTIAL_FLUSH 1
#define | Z_SYNC_FLUSH 2
#define | Z_FULL_FLUSH 3
#define | Z_FINISH 4
#define | Z_BLOCK 5
#define | Z_TREES 6
#define | Z_OK 0
#define | Z_STREAM_END 1
#define | Z_NEED_DICT 2
#define | Z_ERRNO (-1)
#define | Z_STREAM_ERROR (-2)
#define | Z_DATA_ERROR (-3)
#define | Z_MEM_ERROR (-4)
#define | Z_BUF_ERROR (-5)
#define | Z_VERSION_ERROR (-6)
#define | Z_NO_COMPRESSION 0
#define | Z_BEST_SPEED 1
#define | Z_BEST_COMPRESSION 9
#define | Z_DEFAULT_COMPRESSION (-1)
#define | Z_FILTERED 1
#define | Z_HUFFMAN_ONLY 2
#define | Z_RLE 3
#define | Z_FIXED 4
#define | Z_DEFAULT_STRATEGY 0
#define | Z_BINARY 0
#define | Z_TEXT 1
#define | Z_ASCII Z_TEXT /* for compatibility with 1.2.2 and earlier */
#define | Z_UNKNOWN 2
#define | Z_DEFLATED 8
#define | Z_NULL 0 /* for initializing zalloc, zfree, opaque */
#define | zlib_version zlibVersion()
#define | deflateInit(strm, level) deflateInit_((strm), (level), ZLIB_VERSION, (int)sizeof(z_stream))
#define | inflateInit(strm) inflateInit_((strm), ZLIB_VERSION, (int)sizeof(z_stream))
#define | deflateInit2(strm, level, method, windowBits, memLevel, strategy)
#define | inflateInit2(strm, windowBits)
#define | inflateBackInit(strm, windowBits, window)
#define | gzgetc(g) ((g)->have ? ((g)->have--, (g)->pos++, *((g)->next)++) : (gzgetc)(g))

## Typedefs
typedef voidpf alloc_func | OF((voidpf opaque, uInt items, uInt size))
typedef struct z_stream_s | z_stream
typedef z_stream FAR * | z_streamp
typedef struct gz_header_s | gz_header
typedef gz_header FAR * | gz_headerp
typedef struct gzFile_s * | gzFile

## Functions
ZEXTERN const char *ZEXPORT zlibVersion | OF ((void))
ZEXTERN int ZEXPORT deflate | OF ((z_streamp strm, int flush))
ZEXTERN int ZEXPORT deflateEnd | OF ((z_streamp strm))
ZEXTERN int ZEXPORT deflateSetDictionary | OF ((z_streamp strm, const Bytef *dictionary, uInt dictLength))
ZEXTERN int ZEXPORT deflateGetDictionary | OF ((z_streamp strm, Bytef *dictionary, uInt *dictLength))
ZEXTERN int ZEXPORT deflateCopy | OF ((z_streamp dest, z_streamp source))
ZEXTERN int ZEXPORT deflateParams | OF ((z_streamp strm, int level, int strategy))
ZEXTERN int ZEXPORT deflateTune | OF ((z_streamp strm, int good_length, int max_lazy, int nice_length, int max_chain))
ZEXTERN uLong ZEXPORT deflateBound | OF ((z_streamp strm, uLong sourceLen))
ZEXTERN int ZEXPORT deflatePending | OF ((z_streamp strm, unsigned *pending, int *bits))
ZEXTERN int ZEXPORT deflatePrime | OF ((z_streamp strm, int bits, int value))
ZEXTERN int ZEXPORT deflateSetHeader | OF ((z_streamp strm, gz_headerp head))
ZEXTERN int ZEXPORT inflateReset2 | OF ((z_streamp strm, int windowBits))
ZEXTERN int ZEXPORT inflateBack | OF ((z_streamp strm, in_func in, void FAR *in_desc, out_func out, void FAR *out_desc))
ZEXTERN int ZEXPORT compress | OF ((Bytef *dest, uLongf *destLen, const Bytef *source, uLong sourceLen))
ZEXTERN int ZEXPORT compress2 | OF ((Bytef *dest, uLongf *destLen, const Bytef *source, uLong sourceLen, int level))
ZEXTERN uLong ZEXPORT compressBound | OF ((uLong sourceLen))
ZEXTERN int ZEXPORT uncompress2 | OF ((Bytef *dest, uLongf *destLen, const Bytef *source, uLong *sourceLen))
ZEXTERN gzFile ZEXPORT gzdopen | OF ((int fd, const char *mode))
ZEXTERN int ZEXPORT gzbuffer | OF ((gzFile file, unsigned size))
ZEXTERN int ZEXPORT gzsetparams | OF ((gzFile file, int level, int strategy))
ZEXTERN int ZEXPORT gzread | OF ((gzFile file, voidp buf, unsigned len))
ZEXTERN z_size_t ZEXPORT gzfread | OF ((voidp buf, z_size_t size, z_size_t nitems, gzFile file))
ZEXTERN int ZEXPORT gzwrite | OF ((gzFile file, voidpc buf, unsigned len))
ZEXTERN z_size_t ZEXPORT gzfwrite | OF ((voidpc buf, z_size_t size, z_size_t nitems, gzFile file))
ZEXTERN int ZEXPORTVA gzprintf | Z_ARG ((gzFile file, const char *format,...))
ZEXTERN int ZEXPORT gzputs | OF ((gzFile file, const char *s))
ZEXTERN char *ZEXPORT gzgets | OF ((gzFile file, char *buf, int len))
ZEXTERN int ZEXPORT gzputc | OF ((gzFile file, int c))
ZEXTERN int ZEXPORT gzgetc | OF ((gzFile file))
ZEXTERN int ZEXPORT gzungetc | OF ((int c, gzFile file))
ZEXTERN int ZEXPORT gzflush | OF ((gzFile file, int flush))
ZEXTERN const char *ZEXPORT gzerror | OF ((gzFile file, int *errnum))
ZEXTERN uLong ZEXPORT adler32 | OF ((uLong adler, const Bytef *buf, uInt len))
ZEXTERN uLong ZEXPORT adler32_z | OF ((uLong adler, const Bytef *buf, z_size_t len))
ZEXTERN uLong ZEXPORT crc32 | OF ((uLong crc, const Bytef *buf, uInt len))
ZEXTERN uLong ZEXPORT crc32_z | OF ((uLong crc, const Bytef *buf, z_size_t len))
ZEXTERN uLong ZEXPORT crc32_combine_op | OF ((uLong crc1, uLong crc2, uLong op))
ZEXTERN int ZEXPORT deflateInit_ | OF ((z_streamp strm, int level, const char *version, int stream_size))
ZEXTERN int ZEXPORT inflateInit_ | OF ((z_streamp strm, const char *version, int stream_size))
ZEXTERN int ZEXPORT deflateInit2_ | OF ((z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy, const char *version, int stream_size))
ZEXTERN int ZEXPORT inflateInit2_ | OF ((z_streamp strm, int windowBits, const char *version, int stream_size))
ZEXTERN int ZEXPORT inflateBackInit_ | OF ((z_streamp strm, int windowBits, unsigned char FAR *window, const char *version, int stream_size))
ZEXTERN gzFile ZEXPORT gzopen | OF ((const char *, const char *))
ZEXTERN z_off_t ZEXPORT gzseek | OF ((gzFile, z_off_t, int))
ZEXTERN z_off_t ZEXPORT gztell | OF ((gzFile))
ZEXTERN uLong ZEXPORT adler32_combine | OF ((uLong, uLong, z_off_t))
ZEXTERN uLong ZEXPORT crc32_combine_gen | OF ((z_off_t))
ZEXTERN const char *ZEXPORT zError | OF ((int))
ZEXTERN int ZEXPORT inflateSyncPoint | OF ((z_streamp))
ZEXTERN int ZEXPORT inflateUndermine | OF ((z_streamp, int))
ZEXTERN int ZEXPORTVA gzvprintf | Z_ARG ((gzFile file, const char *format, va_list va))

## Macro Definition Documentation

## ◆ deflateInit

#define deflateInit | ( |  | strm,
|  |  | level
| ) |  | deflateInit_((strm), (level), ZLIB_VERSION, (int)sizeof(z_stream))

Definition at line 1810 of file zlib.h.

## ◆ deflateInit2

#define deflateInit2 | ( |  | strm,
|  |  | level,
|  |  | method,
|  |  | windowBits,
|  |  | memLevel,
|  |  | strategy
| ) |  |

Value:
deflateInit2_((strm),(level),(method),(windowBits),(memLevel),\
(strategy), ZLIB_VERSION, (int)sizeof(z_stream))
deflateInit2_
int ZEXPORT deflateInit2_(z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy, const char *version, int stream_size)
Definition: deflate.c:237
z_stream_s
Definition: zlib.h:86
ZLIB_VERSION
#define ZLIB_VERSION
Definition: zlib.h:40

Definition at line 1814 of file zlib.h.

## ◆ gzgetc

#define gzgetc | ( |  | g | ) | ((g)->have ? ((g)->have--, (g)->pos++, *((g)->next)++) : (gzgetc)(g))

Definition at line 1845 of file zlib.h.

## ◆ inflateBackInit

#define inflateBackInit | ( |  | strm,
|  |  | windowBits,
|  |  | window
| ) |  |

Value:
inflateBackInit_((strm), (windowBits), (window), \
ZLIB_VERSION, (int)sizeof(z_stream))
inflateBackInit_
int ZEXPORT inflateBackInit_(z_streamp strm, int windowBits, unsigned char FAR *window, const char *version, int stream_size)
Definition: infback.c:28

Definition at line 1820 of file zlib.h.

## ◆ inflateInit

#define inflateInit | ( |  | strm | ) | inflateInit_((strm), ZLIB_VERSION, (int)sizeof(z_stream))

Definition at line 1812 of file zlib.h.

## ◆ inflateInit2

#define inflateInit2 | ( |  | strm,
|  |  | windowBits
| ) |  |

Value:
inflateInit2_((strm), (windowBits), ZLIB_VERSION, \
(int)sizeof(z_stream))
inflateInit2_
int ZEXPORT inflateInit2_(z_streamp strm, int windowBits, const char *version, int stream_size)
Definition: inflate.c:198

Definition at line 1817 of file zlib.h.

## ◆ Z_ASCII

#define Z_ASCII Z_TEXT /* for compatibility with 1.2.2 and earlier */

Definition at line 205 of file zlib.h.

## ◆ Z_BEST_COMPRESSION

#define Z_BEST_COMPRESSION 9

Definition at line 192 of file zlib.h.

## ◆ Z_BEST_SPEED

#define Z_BEST_SPEED 1

Definition at line 191 of file zlib.h.

## ◆ Z_BINARY

#define Z_BINARY 0

Definition at line 203 of file zlib.h.

## ◆ Z_BLOCK

#define Z_BLOCK 5

Definition at line 173 of file zlib.h.

## ◆ Z_BUF_ERROR

#define Z_BUF_ERROR (-5)

Definition at line 184 of file zlib.h.

## ◆ Z_DATA_ERROR

#define Z_DATA_ERROR (-3)

Definition at line 182 of file zlib.h.

## ◆ Z_DEFAULT_COMPRESSION

#define Z_DEFAULT_COMPRESSION (-1)

Definition at line 193 of file zlib.h.

## ◆ Z_DEFAULT_STRATEGY

#define Z_DEFAULT_STRATEGY 0

Definition at line 200 of file zlib.h.

## ◆ Z_DEFLATED

#define Z_DEFLATED 8

Definition at line 209 of file zlib.h.

## ◆ Z_ERRNO

#define Z_ERRNO (-1)

Definition at line 180 of file zlib.h.

## ◆ Z_FILTERED

#define Z_FILTERED 1

Definition at line 196 of file zlib.h.

## ◆ Z_FINISH

#define Z_FINISH 4

Definition at line 172 of file zlib.h.

## ◆ Z_FIXED

#define Z_FIXED 4

Definition at line 199 of file zlib.h.

## ◆ Z_FULL_FLUSH

#define Z_FULL_FLUSH 3

Definition at line 171 of file zlib.h.

## ◆ Z_HUFFMAN_ONLY

#define Z_HUFFMAN_ONLY 2

Definition at line 197 of file zlib.h.

## ◆ Z_MEM_ERROR

#define Z_MEM_ERROR (-4)

Definition at line 183 of file zlib.h.

## ◆ Z_NEED_DICT

#define Z_NEED_DICT 2

Definition at line 179 of file zlib.h.

## ◆ Z_NO_COMPRESSION

#define Z_NO_COMPRESSION 0

Definition at line 190 of file zlib.h.

## ◆ Z_NO_FLUSH

#define Z_NO_FLUSH 0

Definition at line 168 of file zlib.h.

## ◆ Z_NULL

#define Z_NULL 0 /* for initializing zalloc, zfree, opaque */

Definition at line 212 of file zlib.h.

## ◆ Z_OK

#define Z_OK 0

Definition at line 177 of file zlib.h.

## ◆ Z_PARTIAL_FLUSH

#define Z_PARTIAL_FLUSH 1

Definition at line 169 of file zlib.h.

## ◆ Z_RLE

#define Z_RLE 3

Definition at line 198 of file zlib.h.

## ◆ Z_STREAM_END

#define Z_STREAM_END 1

Definition at line 178 of file zlib.h.

## ◆ Z_STREAM_ERROR

#define Z_STREAM_ERROR (-2)

Definition at line 181 of file zlib.h.

## ◆ Z_SYNC_FLUSH

#define Z_SYNC_FLUSH 2

Definition at line 170 of file zlib.h.

## ◆ Z_TEXT

#define Z_TEXT 1

Definition at line 204 of file zlib.h.

## ◆ Z_TREES

#define Z_TREES 6

Definition at line 174 of file zlib.h.

## ◆ Z_UNKNOWN

#define Z_UNKNOWN 2

Definition at line 206 of file zlib.h.

## ◆ Z_VERSION_ERROR

#define Z_VERSION_ERROR (-6)

Definition at line 185 of file zlib.h.

## ◆ ZLIB_VER_MAJOR

#define ZLIB_VER_MAJOR 1

Definition at line 42 of file zlib.h.

## ◆ ZLIB_VER_MINOR

#define ZLIB_VER_MINOR 2

Definition at line 43 of file zlib.h.

## ◆ ZLIB_VER_REVISION

#define ZLIB_VER_REVISION 13

Definition at line 44 of file zlib.h.

## ◆ ZLIB_VER_SUBREVISION

#define ZLIB_VER_SUBREVISION 0

Definition at line 45 of file zlib.h.

## ◆ ZLIB_VERNUM

#define ZLIB_VERNUM 0x12d0

Definition at line 41 of file zlib.h.

## ◆ ZLIB_VERSION

#define ZLIB_VERSION "1.2.13"

Definition at line 40 of file zlib.h.

## ◆ zlib_version

#define zlib_version zlibVersion()

Definition at line 214 of file zlib.h.

## Typedef Documentation

## ◆ gz_header

typedef struct gz_header_s gz_header

## ◆ gz_headerp

typedef gz_header FAR* gz_headerp

Definition at line 131 of file zlib.h.

## ◆ gzFile

typedef struct gzFile_s* gzFile

Definition at line 1302 of file zlib.h.

## ◆ OF

typedef int out_func OF((void FAR *, unsigned char FAR *, unsigned))

Definition at line 81 of file zlib.h.

## ◆ z_stream

typedef struct z_stream_s z_stream

## ◆ z_streamp

typedef z_stream FAR* z_streamp

Definition at line 108 of file zlib.h.

## Function Documentation

## ◆ OF() [1/50]

ZEXTERN int ZEXPORT uncompress2 OF | ( | (Bytef *dest, uLongf *destLen, const Bytef *source, uLong *sourceLen) |  | ) |

## ◆ OF() [2/50]

ZEXTERN int ZEXPORT compress OF | ( | (Bytef *dest, uLongf *destLen, const Bytef *source, uLong sourceLen) |  | ) |

## ◆ OF() [3/50]

ZEXTERN int ZEXPORT compress2 OF | ( | (Bytef *dest, uLongf *destLen, const Bytef *source, uLong sourceLen, int level) |  | ) |

## ◆ OF() [4/50]

ZEXTERN gzFile ZEXPORT gzopen OF | ( | (const char *, const char *) |  | ) |

## ◆ OF() [5/50]

ZEXTERN int ZEXPORT gzgetc OF | ( | (gzFile file) |  | ) |

## ◆ OF() [6/50]

ZEXTERN char *ZEXPORT gzgets OF | ( | (gzFile file, char *buf, int len) |  | ) |

## ◆ OF() [7/50]

ZEXTERN int ZEXPORT gzputs OF | ( | (gzFile file, const char *s) |  | ) |

## ◆ OF() [8/50]

ZEXTERN const char *ZEXPORT gzerror OF | ( | (gzFile file, int *errnum) |  | ) |

## ◆ OF() [9/50]

ZEXTERN int ZEXPORT gzputc OF | ( | (gzFile file, int c) |  | ) |

## ◆ OF() [10/50]

ZEXTERN int ZEXPORT gzflush OF | ( | (gzFile file, int flush) |  | ) |

## ◆ OF() [11/50]

ZEXTERN int ZEXPORT gzsetparams OF | ( | (gzFile file, int level, int strategy) |  | ) |

## ◆ OF() [12/50]

ZEXTERN int ZEXPORT gzbuffer OF | ( | (gzFile file, unsigned size) |  | ) |

## ◆ OF() [13/50]

ZEXTERN int ZEXPORT gzread OF | ( | (gzFile file, voidp buf, unsigned len) |  | ) |

## ◆ OF() [14/50]

ZEXTERN int ZEXPORT gzwrite OF | ( | (gzFile file, voidpc buf, unsigned len) |  | ) |

## ◆ OF() [15/50]

ZEXTERN z_off_t ZEXPORT gztell OF | ( | (gzFile) |  | ) |

## ◆ OF() [16/50]

ZEXTERN z_off_t ZEXPORT gzseek OF | ( | (gzFile, z_off_t, int) |  | ) |

## ◆ OF() [17/50]

ZEXTERN int ZEXPORT gzungetc OF | ( | (int c, gzFile file) |  | ) |

## ◆ OF() [18/50]

ZEXTERN gzFile ZEXPORT gzdopen OF | ( | (int fd, const char *mode) |  | ) |

## ◆ OF() [19/50]

ZEXTERN const char *ZEXPORT zError OF | ( | (int) |  | ) |

## ◆ OF() [20/50]

ZEXTERN uLong ZEXPORT adler32 OF | ( | (uLong adler, const Bytef *buf, uInt len) |  | ) |

## ◆ OF() [21/50]

ZEXTERN uLong ZEXPORT adler32_z OF | ( | (uLong adler, const Bytef *buf, z_size_t len) |  | ) |

## ◆ OF() [22/50]

ZEXTERN uLong ZEXPORT crc32 OF | ( | (uLong crc, const Bytef *buf, uInt len) |  | ) |

## ◆ OF() [23/50]

ZEXTERN uLong ZEXPORT crc32_z OF | ( | (uLong crc, const Bytef *buf, z_size_t len) |  | ) |

## ◆ OF() [24/50]

ZEXTERN uLong ZEXPORT crc32_combine_op OF | ( | (uLong crc1, uLong crc2, uLong op) |  | ) |

## ◆ OF() [25/50]

ZEXTERN uLong ZEXPORT compressBound OF | ( | (uLong sourceLen) |  | ) |

## ◆ OF() [26/50]

ZEXTERN uLong ZEXPORT adler32_combine OF | ( | (uLong, uLong, z_off_t) |  | ) |

## ◆ OF() [27/50]

ZEXTERN const char *ZEXPORT zlibVersion OF | ( | (void) |  | ) |

## ◆ OF() [28/50]

ZEXTERN z_size_t ZEXPORT gzfread OF | ( | (voidp buf, z_size_t size, z_size_t nitems, gzFile file) |  | ) |

## ◆ OF() [29/50]

ZEXTERN z_size_t ZEXPORT gzfwrite OF | ( | (voidpc buf, z_size_t size, z_size_t nitems, gzFile file) |  | ) |

## ◆ OF() [30/50]

ZEXTERN uLong ZEXPORT crc32_combine_gen OF | ( | (z_off_t) |  | ) |

## ◆ OF() [31/50]

ZEXTERN int ZEXPORT deflateCopy OF | ( | (z_streamp dest, z_streamp source) |  | ) |

## ◆ OF() [32/50]

ZEXTERN int ZEXPORT deflateEnd OF | ( | (z_streamp strm) |  | ) |

## ◆ OF() [33/50]

ZEXTERN int ZEXPORT deflateGetDictionary OF | ( | (z_streamp strm, Bytef *dictionary, uInt *dictLength) |  | ) |

## ◆ OF() [34/50]

ZEXTERN int ZEXPORT deflateSetDictionary OF | ( | (z_streamp strm, const Bytef *dictionary, uInt dictLength) |  | ) |

## ◆ OF() [35/50]

ZEXTERN int ZEXPORT inflateInit_ OF | ( | (z_streamp strm, const char *version, int stream_size) |  | ) |

## ◆ OF() [36/50]

ZEXTERN int ZEXPORT deflateSetHeader OF | ( | (z_streamp strm, gz_headerp head) |  | ) |

## ◆ OF() [37/50]

ZEXTERN int ZEXPORT inflateBack OF | ( | (z_streamp strm, in_func in, void FAR *in_desc, out_func out, void FAR *out_desc) |  | ) |

## ◆ OF() [38/50]

ZEXTERN int ZEXPORT deflatePrime OF | ( | (z_streamp strm, int bits, int value) |  | ) |

## ◆ OF() [39/50]

ZEXTERN int ZEXPORT deflate OF | ( | (z_streamp strm, int flush) |  | ) |

## ◆ OF() [40/50]

ZEXTERN int ZEXPORT deflateTune OF | ( | (z_streamp strm, int good_length, int max_lazy, int nice_length, int max_chain) |  | ) |

## ◆ OF() [41/50]

ZEXTERN int ZEXPORT deflateInit_ OF | ( | (z_streamp strm, int level, const char *version, int stream_size) |  | ) |

## ◆ OF() [42/50]

ZEXTERN int ZEXPORT deflateInit2_ OF | ( | (z_streamp strm, int level, int method, int windowBits, int memLevel, int strategy, const char *version, int stream_size) |  | ) |

## ◆ OF() [43/50]

ZEXTERN int ZEXPORT deflateParams OF | ( | (z_streamp strm, int level, int strategy) |  | ) |

## ◆ OF() [44/50]

ZEXTERN int ZEXPORT inflateReset2 OF | ( | (z_streamp strm, int windowBits) |  | ) |

## ◆ OF() [45/50]

ZEXTERN int ZEXPORT inflateInit2_ OF | ( | (z_streamp strm, int windowBits, const char *version, int stream_size) |  | ) |

## ◆ OF() [46/50]

ZEXTERN int ZEXPORT inflateBackInit_ OF | ( | (z_streamp strm, int windowBits, unsigned char FAR *window, const char *version, int stream_size) |  | ) |

## ◆ OF() [47/50]

ZEXTERN uLong ZEXPORT deflateBound OF | ( | (z_streamp strm, uLong sourceLen) |  | ) |

## ◆ OF() [48/50]

ZEXTERN int ZEXPORT deflatePending OF | ( | (z_streamp strm, unsigned *pending, int *bits) |  | ) |

## ◆ OF() [49/50]

ZEXTERN int ZEXPORT inflateSyncPoint OF | ( | (z_streamp) |  | ) |

## ◆ OF() [50/50]

ZEXTERN int ZEXPORT inflateUndermine OF | ( | (z_streamp, int) |  | ) |

## ◆ Z_ARG() [1/2]

ZEXTERN int ZEXPORTVA gzvprintf Z_ARG | ( | (gzFile file, const char *format, va_list va) |  | ) |

## ◆ Z_ARG() [2/2]

ZEXTERN int ZEXPORTVA gzprintf Z_ARG | ( | (gzFile file, const char *format,...) |  | ) |